#
#    Copyright (C) 2007    Dmitry Ivanov, vonami@gmail.com
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

#!/usr/bin/env ruby

filename = ARGV[0]
if !filename then
        puts "Name of the file is not specified"
        exit
end

file = File.new(filename, "w")

file.puts "#ifndef PARTIMAGENG_BITSHASH"
file.puts "#define PARTIMAGENG_BITSHASH"
file.puts
file.puts "#include <sys/types.h>"
file.puts
file.puts "static const u_int8_t bits_hash[256] = {"

i = 0
while ( i < 256 ) do

        nbits = 0
        bit = 0
        while ( bit < 8 ) do
                if (i & (1 << bit) != 0 ) then
                        nbits += 1
                end
                bit += 1
        end
        file.write "        " + nbits.to_s
        if i != 255 then
                file.puts ","
        else
                file.puts
        end
        i += 1
end

file.puts "};"
file.puts
file.puts "#endif /* PARTIMAGENG_BITSHASH */"

file.close
